#ifndef MPSOA_included

#define MPSOA_included

#include<stdio.h>
#include<stdlib.h>
#include<time.h>
#include<math.h>


enum { /* Exit codes */ 
  EXIT_OK = 0,
  EXIT_KO = 1,
  EXIT_MEM = 2,
};

#define Inf 1.0E20

typedef struct { char *msg; } Exit_code;

static Exit_code exit_codes[] = {
  {"Normal exit"},                /* 0 */
  {"Abnormal exit"},              /* 1 */
  {"Failed to allocate memory"},  /* 2 */
};


struct swarm {
  double *x;    /* particles */
  double *v;    /* velocities */
  double *y;    /* best particle so far */
  double *ygrd; /* best particle so far gradient, for clustering */
  double *fy;   /* best particle so far objective function */
};


struct Options {
  int s;              /* swarm size */
  int prog;           /* progress in last prog iterations */
  double mu, nu;      /* cognitial and social parameters */
  double maxvfactor;  /* maximum velocity factor */
  int maxiter;        /* maximum of iterations */
  double iweight;     /* inital weight */
  double fweight;     /* final weight */
  double n2grd;       /* tolerance for gradient norm */
  int halton;         /* if a halton initial swarm is to be used */
  int mlocal;         /* multilocal (!=0) and global (=0) optimization */
  int verb;           /* verbosity level 0=quiet, 1=short info, 2=all info */
};





void print_pop(int ,int , struct swarm *);
double halton(int , int );


#endif
