###############################################################################
# Objective: Generic
# Constraints: Simple bounds
###############################################################################
#
#  Price PhD. Thesis
#   As described in C.J. Price 
#    "Nonlinear Semi-infinite Programming",
#    PhD. Thesis submitted to University of Canterbury,
#    New Zealand, August 1992.
#
#   Problem S n=6
#    Coded by A. Ismael F. Vaz 24/12/1999  aivaz@dps.uminho.pt
#    University of Minho, Portugal
#
#
# Adapted for multilocal optimization by A. Ismael F. Vaz 14/04/2004
#
# This is a regular (finite) maximization problem...
#
###############################################################################

#number of t
param nt;

param x{1..4};

# t variable
var t {1..nt};

maximize ft:
	2*(x[1]^2+x[2]^2+x[3]^2+x[4]^2)-6-2*nt
	+sin(t[1]-x[1]-x[4])+sin(t[2]-x[2]-x[3])
	+sin(t[3]-x[1])+sin(2*t[4]-x[2])+sin(t[5]-x[3])+sin(2*t[6]-x[4]);

subject to bounds {i in 1..nt}:
	0 <= t[i] <= 2;

data;


param nt := 6;

param x :=
	1	0.969021
	2	-1.456291
	3	1.581476
	4	-0.905873;

option solver mlocpsoa;
solve;

##################
# Solution found #
##################
printf "Solution found\n";
display t;
display ft;
